## taglib 2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.31)

project(taglib)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

include(CTest)
include(FeatureSummary)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
if(APPLE)
  option(BUILD_FRAMEWORK "Build a macOS framework" OFF)
  if(BUILD_FRAMEWORK)
    set(BUILD_SHARED_LIBS ON)
    #set(CMAKE_MACOSX_RPATH 1)
    set(FRAMEWORK_INSTALL_DIR "/Library/Frameworks" CACHE STRING "Directory to install frameworks to.")
  endif()
endif()
option(ENABLE_STATIC_RUNTIME "Visual Studio, link with runtime statically" OFF)

option(ENABLE_CCACHE "Use ccache when building libtag" OFF)
if(ENABLE_CCACHE)
  find_program(CCACHE_FOUND ccache)
  if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
  endif()
endif()

option(VISIBILITY_HIDDEN "Build with -fvisibility=hidden" OFF)
option(BUILD_EXAMPLES "Build the examples" OFF)
option(BUILD_BINDINGS "Build the bindings" ON)

option(NO_ITUNES_HACKS "Disable workarounds for iTunes bugs" OFF)

option(PLATFORM_WINRT "Enable WinRT support" OFF)
if(PLATFORM_WINRT)
  add_definitions(-DPLATFORM_WINRT)
endif()

set(TAGLIB_INSTALL_SUFFIX "" CACHE STRING
  "Suffix added to installed files (include directory, libraries, .pc)")

add_definitions(-DHAVE_CONFIG_H)
set(TESTS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/tests/" CACHE STRING
  "Tests directory, is path to unit test data when 'data' is appended")
set(TESTS_TMPDIR "" CACHE STRING
  "Directory for temporary files created during unit tests, system tmpdir is used if undefined")

if(CMAKE_C_COMPILER_ID MATCHES "^(GNU|Clang|AppleClang)$")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "^(GNU|Clang|AppleClang)$")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif()

if(MSVC)
  if(ENABLE_STATIC_RUNTIME)
    foreach(flag_var CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
    endforeach(flag_var)
  endif()
endif()

# Read version information from file taglib/toolkit/taglib.h into variables
# TAGLIB_LIB_MAJOR_VERSION, TAGLIB_LIB_MINOR_VERSION, TAGLIB_LIB_PATCH_VERSION.
foreach(version_part MAJOR MINOR PATCH)
  set(version_var_name "TAGLIB_${version_part}_VERSION")
  file(STRINGS taglib/toolkit/taglib.h version_line
       REGEX "^#define +${version_var_name}")
  if(NOT version_line)
    message(FATAL_ERROR "${version_var_name} not found in taglib.h")
  endif()
  string(REGEX MATCH "${version_var_name} +([^ ]+)" result ${version_line})
  set(TAGLIB_LIB_${version_part}_VERSION ${CMAKE_MATCH_1})
endforeach(version_part)

# Only used to force cmake rerun when taglib.h changes.
configure_file(taglib/toolkit/taglib.h ${CMAKE_CURRENT_BINARY_DIR}/taglib.h.stamp)

if("${TAGLIB_LIB_PATCH_VERSION}" EQUAL "0")
  set(TAGLIB_LIB_VERSION_STRING "${TAGLIB_LIB_MAJOR_VERSION}.${TAGLIB_LIB_MINOR_VERSION}")
else()
  set(TAGLIB_LIB_VERSION_STRING "${TAGLIB_LIB_MAJOR_VERSION}.${TAGLIB_LIB_MINOR_VERSION}.${TAGLIB_LIB_PATCH_VERSION}")
endif()

# Major version: increase it if you break ABI compatibility.
# Minor version: increase it if you add ABI compatible features.
# Patch version: increase it for bug fix releases.
set(TAGLIB_SOVERSION_MAJOR 2)
set(TAGLIB_SOVERSION_MINOR 2)
set(TAGLIB_SOVERSION_PATCH 0)

include(ConfigureChecks.cmake)

option(WITH_APE "Build with APE, MPC, WavPack" ON)
option(WITH_ASF "Build with ASF" ON)
option(WITH_DSF "Build with DSF" ON)
option(WITH_MATROSKA "Build with Matroska" ON)
option(WITH_MOD "Build with Tracker modules" ON)
option(WITH_MP4 "Build with MP4" ON)
option(WITH_RIFF "Build with AIFF, RIFF, WAV" ON)
option(WITH_SHORTEN "Build with Shorten" ON)
option(WITH_TRUEAUDIO "Build with TrueAudio" ON)
option(WITH_VORBIS "Build with Vorbis, FLAC, Ogg, Opus" ON)

# Determine whether zlib is installed.
option(WITH_ZLIB "Build with ZLIB" ON)

if(WITH_ZLIB)
  find_package("ZLIB")
  set(HAVE_ZLIB ${ZLIB_FOUND})
  if(ZLIB_FOUND)
    set(ZLIB_LIBRARIES_FLAGS -lz)
    if(NOT BUILD_SHARED_LIBS)
      # When linking TagLib statically, zlib has to be linked explicitly.
      set(ZLIB_INTERFACE_LINK_LIBRARIES ZLIB::ZLIB)
    endif()
  endif()
endif()

if(NOT WIN32)
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/taglib-config.cmake" "${CMAKE_CURRENT_BINARY_DIR}/taglib-config" @ONLY)
  install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/taglib-config" DESTINATION "${CMAKE_INSTALL_BINDIR}"
          RENAME "taglib${TAGLIB_INSTALL_SUFFIX}-config")
endif()

if(WIN32)
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/taglib-config.cmd.cmake" "${CMAKE_CURRENT_BINARY_DIR}/taglib-config.cmd")
  install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/taglib-config.cmd" DESTINATION "${CMAKE_INSTALL_BINDIR}"
          RENAME "taglib${TAGLIB_INSTALL_SUFFIX}-config.cmd")
endif()

if(NOT BUILD_FRAMEWORK)
  if(IS_ABSOLUTE ${CMAKE_INSTALL_INCLUDEDIR})
    set(CMAKE_PC_INCLUDEDIR ${CMAKE_INSTALL_INCLUDEDIR})
  else()
    set(CMAKE_PC_INCLUDEDIR "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
  endif()
  if(IS_ABSOLUTE ${CMAKE_INSTALL_LIBDIR})
    set(CMAKE_PC_LIBDIR ${CMAKE_INSTALL_LIBDIR})
  else()
    set(CMAKE_PC_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
  endif()
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/taglib.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/taglib.pc" @ONLY)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/taglib.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
          RENAME "taglib${TAGLIB_INSTALL_SUFFIX}.pc")
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR})
configure_file(config.h.cmake "${CMAKE_CURRENT_BINARY_DIR}/config.h")

option(TRACE_IN_RELEASE "Output debug messages even in release mode" OFF)
if(TRACE_IN_RELEASE)
  set(TRACE_IN_RELEASE TRUE)
endif()

find_package(utf8cpp QUIET)
if(utf8cpp_FOUND)
  message(STATUS "Using utfcpp ${utf8cpp_VERSION} from ${utf8cpp_CONFIG}")
else()
  find_path(utf8cpp_INCLUDE_DIR NAMES utf8.h PATH_SUFFIXES utf8cpp
            DOC "utf8cpp include directory")
  mark_as_advanced(utf8cpp_INCLUDE_DIR)
  include(FindPackageHandleStandardArgs)
  find_package_handle_standard_args(utf8cpp REQUIRED_VARS utf8cpp_INCLUDE_DIR)
  if(utf8cpp_FOUND)
    set(utf8cpp_INCLUDE_DIRS "${utf8cpp_INCLUDE_DIR}")
    if(NOT TARGET utf8::cpp)
      add_library(utf8::cpp INTERFACE IMPORTED)
      set_target_properties(utf8::cpp PROPERTIES
        INTERFACE_INCLUDE_DIRECTORIES "${utf8cpp_INCLUDE_DIR}")
    endif()
    message(STATUS "Using utfcpp from ${utf8cpp_INCLUDE_DIR}")
  else()
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/utfcpp/CMakeLists.txt)
      add_subdirectory("3rdparty/utfcpp")
      message(STATUS "Using utfcpp from ${utf8cpp_SOURCE_DIR}")
    else()
      message(FATAL_ERROR
        "utfcpp not found. Either install package (probably utfcpp, utf8cpp, or libutfcpp-dev) "
        "or fetch the git submodule using\n"
        "git submodule update --init")
    endif()
  endif()
endif()

if(WITH_APE)
  set(TAGLIB_WITH_APE TRUE)
endif()
if(WITH_ASF)
  set(TAGLIB_WITH_ASF TRUE)
endif()
if(WITH_DSF)
  set(TAGLIB_WITH_DSF TRUE)
endif()
if(WITH_MATROSKA)
  set(TAGLIB_WITH_MATROSKA TRUE)
endif()
if(WITH_MOD)
  set(TAGLIB_WITH_MOD TRUE)
endif()
if(WITH_MP4)
  set(TAGLIB_WITH_MP4 TRUE)
endif()
if(WITH_RIFF)
  set(TAGLIB_WITH_RIFF TRUE)
endif()
if(WITH_SHORTEN)
  set(TAGLIB_WITH_SHORTEN TRUE)
endif()
if(WITH_TRUEAUDIO)
  set(TAGLIB_WITH_TRUEAUDIO TRUE)
endif()
if(WITH_VORBIS)
  set(TAGLIB_WITH_VORBIS TRUE)
endif()

configure_file(taglib/taglib_config.h.cmake "${CMAKE_CURRENT_BINARY_DIR}/taglib_config.h")

add_subdirectory(taglib)

if(BUILD_BINDINGS)
  add_subdirectory(bindings)
endif()

if(BUILD_TESTING)
  find_package(CppUnit)
  if(CppUnit_FOUND)
    add_subdirectory(tests)
  else()
    message(WARNING "BUILD_TESTING requested, but CppUnit not found, skipping tests.")
  endif()
endif()

if(BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.cmake" "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile")
add_custom_target(docs doxygen)

# uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)

if(NOT TARGET uninstall)
  add_custom_target(uninstall COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif()

feature_summary(WHAT ALL   FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== examples/CMakeLists.txt ===
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/toolkit
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/ape
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/matroska
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mpeg
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mpeg/id3v1
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mpeg/id3v2
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mpeg/id3v2/frames
  ${CMAKE_CURRENT_SOURCE_DIR}/../bindings/c/
)

if(NOT BUILD_SHARED_LIBS)
  add_definitions(-DTAGLIB_STATIC)
endif()

########### next target ###############

add_executable(tagreader tagreader.cpp)
target_link_libraries(tagreader tag)

########### next target ###############

add_executable(tagreader_c tagreader_c.c)
target_link_libraries(tagreader_c tag_c)

########### next target ###############

add_executable(tagwriter tagwriter.cpp)
target_link_libraries(tagwriter tag)

########### next target ###############

add_executable(framelist framelist.cpp)
target_link_libraries(framelist tag)

########### next target ###############

add_executable(strip-id3v1 strip-id3v1.cpp)
target_link_libraries(strip-id3v1 tag)

if(WITH_MATROSKA)
  ########### next target ###############

  add_executable(matroskareader matroskareader.cpp)
  target_link_libraries(matroskareader tag)

  ########### next target ###############

  add_executable(matroskawriter matroskawriter.cpp)
  target_link_libraries(matroskawriter tag)
endif()

install(TARGETS tagreader tagreader_c tagwriter framelist strip-id3v1
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== taglib/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(tag_HDR_DIRS
  ${CMAKE_CURRENT_SOURCE_DIR}/toolkit
  ${CMAKE_CURRENT_SOURCE_DIR}/mpeg
  ${CMAKE_CURRENT_SOURCE_DIR}/mpeg/id3v2
  ${CMAKE_CURRENT_SOURCE_DIR}/mpeg/id3v2/frames
  ${CMAKE_CURRENT_SOURCE_DIR}/mpeg/id3v1
)
if(WITH_ASF)
  set(tag_HDR_DIRS ${tag_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/asf
  )
endif()
if(WITH_VORBIS)
  set(tag_HDR_DIRS ${tag_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/ogg
    ${CMAKE_CURRENT_SOURCE_DIR}/ogg/flac
    ${CMAKE_CURRENT_SOURCE_DIR}/flac
    ${CMAKE_CURRENT_SOURCE_DIR}/ogg/vorbis
    ${CMAKE_CURRENT_SOURCE_DIR}/ogg/speex
    ${CMAKE_CURRENT_SOURCE_DIR}/ogg/opus
  )
endif()
if(WITH_APE)
  set(tag_HDR_DIRS ${tag_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/mpc
    ${CMAKE_CURRENT_SOURCE_DIR}/ape
    ${CMAKE_CURRENT_SOURCE_DIR}/wavpack
  )
endif()
if(WITH_MP4)
  set(tag_HDR_DIRS ${tag_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/mp4
  )
endif()
if(WITH_TRUEAUDIO)
  set(tag_HDR_DIRS ${tag_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/trueaudio
  )
endif()
if(WITH_RIFF)
  set(tag_HDR_DIRS ${tag_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/riff
    ${CMAKE_CURRENT_SOURCE_DIR}/riff/aiff
    ${CMAKE_CURRENT_SOURCE_DIR}/riff/wav
  )
endif()
if(WITH_MOD)
  set(tag_HDR_DIRS ${tag_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/mod
    ${CMAKE_CURRENT_SOURCE_DIR}/s3m
    ${CMAKE_CURRENT_SOURCE_DIR}/it
    ${CMAKE_CURRENT_SOURCE_DIR}/xm
  )
endif()
if(WITH_DSF)
  set(tag_HDR_DIRS ${tag_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/dsf
    ${CMAKE_CURRENT_SOURCE_DIR}/dsdiff
  )
endif()
if(WITH_SHORTEN)
  set(tag_HDR_DIRS ${tag_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/shorten
  )
endif()
if(WITH_MATROSKA)
  set(tag_HDR_DIRS ${tag_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/matroska
    ${CMAKE_CURRENT_SOURCE_DIR}/matroska/ebml
  )
endif()
include_directories(${tag_HDR_DIRS})

set(tag_PRIVATE_HDRS)
set(tag_HDRS
  tag.h
  fileref.h
  audioproperties.h
  taglib_export.h
  ${CMAKE_CURRENT_BINARY_DIR}/../taglib_config.h
  toolkit/taglib.h
  toolkit/tstring.h
  toolkit/tlist.h
  toolkit/tlist.tcc
  toolkit/tstringlist.h
  toolkit/tbytevector.h
  toolkit/tbytevectorlist.h
  toolkit/tvariant.h
  toolkit/tbytevectorstream.h
  toolkit/tiostream.h
  toolkit/tfile.h
  toolkit/tfilestream.h
  toolkit/tmap.h
  toolkit/tmap.tcc
  toolkit/tpicturetype.h
  toolkit/tpropertymap.h
  toolkit/tdebuglistener.h
  toolkit/tversionnumber.h
  mpeg/mpegfile.h
  mpeg/mpegproperties.h
  mpeg/mpegheader.h
  mpeg/xingheader.h
  mpeg/id3v1/id3v1tag.h
  mpeg/id3v1/id3v1genres.h
  mpeg/id3v2/id3v2.h
  mpeg/id3v2/id3v2extendedheader.h
  mpeg/id3v2/id3v2frame.h
  mpeg/id3v2/id3v2header.h
  mpeg/id3v2/id3v2synchdata.h
  mpeg/id3v2/id3v2footer.h
  mpeg/id3v2/id3v2framefactory.h
  mpeg/id3v2/id3v2tag.h
  mpeg/id3v2/frames/attachedpictureframe.h
  mpeg/id3v2/frames/commentsframe.h
  mpeg/id3v2/frames/eventtimingcodesframe.h
  mpeg/id3v2/frames/generalencapsulatedobjectframe.h
  mpeg/id3v2/frames/ownershipframe.h
  mpeg/id3v2/frames/popularimeterframe.h
  mpeg/id3v2/frames/privateframe.h
  mpeg/id3v2/frames/relativevolumeframe.h
  mpeg/id3v2/frames/synchronizedlyricsframe.h
  mpeg/id3v2/frames/textidentificationframe.h
  mpeg/id3v2/frames/uniquefileidentifierframe.h
  mpeg/id3v2/frames/unknownframe.h
  mpeg/id3v2/frames/unsynchronizedlyricsframe.h
  mpeg/id3v2/frames/urllinkframe.h
  mpeg/id3v2/frames/chapterframe.h
  mpeg/id3v2/frames/tableofcontentsframe.h
  mpeg/id3v2/frames/podcastframe.h
)
if(WITH_VORBIS)
  set(tag_HDRS ${tag_HDRS}
    ogg/oggfile.h
    ogg/oggpage.h
    ogg/oggpageheader.h
    ogg/xiphcomment.h
    ogg/vorbis/vorbisfile.h
    ogg/vorbis/vorbisproperties.h
    ogg/flac/oggflacfile.h
    ogg/speex/speexfile.h
    ogg/speex/speexproperties.h
    ogg/opus/opusfile.h
    ogg/opus/opusproperties.h
    flac/flacfile.h
    flac/flacpicture.h
    flac/flacproperties.h
    flac/flacmetadatablock.h
  )
endif()
if(WITH_APE)
  set(tag_HDRS ${tag_HDRS}
    ape/apefile.h
    ape/apeproperties.h
    ape/apetag.h
    ape/apefooter.h
    ape/apeitem.h
    mpc/mpcfile.h
    mpc/mpcproperties.h
    wavpack/wavpackfile.h
    wavpack/wavpackproperties.h
  )
endif()
if(WITH_TRUEAUDIO)
  set(tag_HDRS ${tag_HDRS}
    trueaudio/trueaudiofile.h
    trueaudio/trueaudioproperties.h
  )
endif()
if(WITH_RIFF)
  set(tag_HDRS ${tag_HDRS}
    riff/rifffile.h
    riff/aiff/aifffile.h
    riff/aiff/aiffproperties.h
    riff/wav/wavfile.h
    riff/wav/wavproperties.h
    riff/wav/infotag.h
  )
endif()
if(WITH_ASF)
  set(tag_HDRS ${tag_HDRS}
    asf/asffile.h
    asf/asfproperties.h
    asf/asftag.h
    asf/asfattribute.h
    asf/asfpicture.h
  )
endif()
if(WITH_MP4)
  set(tag_HDRS ${tag_HDRS}
    mp4/mp4file.h
    mp4/mp4atom.h
    mp4/mp4tag.h
    mp4/mp4item.h
    mp4/mp4properties.h
    mp4/mp4coverart.h
    mp4/mp4stem.h
    mp4/mp4itemfactory.h
  )
endif()
if(WITH_MOD)
  set(tag_HDRS ${tag_HDRS}
    mod/modfilebase.h
    mod/modfile.h
    mod/modtag.h
    mod/modproperties.h
    it/itfile.h
    it/itproperties.h
    s3m/s3mfile.h
    s3m/s3mproperties.h
    xm/xmfile.h
    xm/xmproperties.h
  )
endif()
if(WITH_DSF)
  set(tag_HDRS ${tag_HDRS}
    dsf/dsffile.h
    dsf/dsfproperties.h
    dsdiff/dsdifffile.h
    dsdiff/dsdiffproperties.h
    dsdiff/dsdiffdiintag.h
  )
endif()
if(WITH_SHORTEN)
  set(tag_HDRS ${tag_HDRS}
    shorten/shortenfile.h
    shorten/shortenproperties.h
    shorten/shortentag.h
  )
endif()
if(WITH_MATROSKA)
  set(tag_HDRS ${tag_HDRS}
    matroska/matroskaattachedfile.h
    matroska/matroskaattachments.h
    matroska/matroskachapter.h
    matroska/matroskachapteredition.h
    matroska/matroskachapters.h
    matroska/matroskaelement.h
    matroska/matroskafile.h
    matroska/matroskaproperties.h
    matroska/matroskasimpletag.h
    matroska/matroskatag.h
  )
  set(tag_PRIVATE_HDRS ${tag_PRIVATE_HDRS}
    matroska/ebml/ebmlbinaryelement.h
    matroska/ebml/ebmlelement.h
    matroska/ebml/ebmlmasterelement.h
    matroska/ebml/ebmlmkattachments.h
    matroska/ebml/ebmlmkchapters.h
    matroska/ebml/ebmlmkcues.h
    matroska/ebml/ebmlmkseekhead.h
    matroska/ebml/ebmlmksegment.h
    matroska/ebml/ebmlmkinfo.h
    matroska/ebml/ebmlmktracks.h
    matroska/ebml/ebmlmktags.h
    matroska/ebml/ebmlstringelement.h
    matroska/ebml/ebmluintelement.h
    matroska/ebml/ebmlfloatelement.h
    matroska/ebml/ebmlutils.h
    matroska/ebml/ebmlvoidelement.h
    matroska/matroskacues.h
    matroska/matroskaseekhead.h
    matroska/matroskasegment.h
  )
endif()

set(mpeg_SRCS
  mpeg/mpegfile.cpp
  mpeg/mpegproperties.cpp
  mpeg/mpegheader.cpp
  mpeg/xingheader.cpp
)

set(id3v1_SRCS
  mpeg/id3v1/id3v1tag.cpp
  mpeg/id3v1/id3v1genres.cpp
)

set(id3v2_SRCS
  mpeg/id3v2/id3v2framefactory.cpp
  mpeg/id3v2/id3v2synchdata.cpp
  mpeg/id3v2/id3v2tag.cpp
  mpeg/id3v2/id3v2header.cpp
  mpeg/id3v2/id3v2frame.cpp
  mpeg/id3v2/id3v2footer.cpp
  mpeg/id3v2/id3v2extendedheader.cpp
  )

set(frames_SRCS
  mpeg/id3v2/frames/attachedpictureframe.cpp
  mpeg/id3v2/frames/commentsframe.cpp
  mpeg/id3v2/frames/eventtimingcodesframe.cpp
  mpeg/id3v2/frames/generalencapsulatedobjectframe.cpp
  mpeg/id3v2/frames/ownershipframe.cpp
  mpeg/id3v2/frames/popularimeterframe.cpp
  mpeg/id3v2/frames/privateframe.cpp
  mpeg/id3v2/frames/relativevolumeframe.cpp
  mpeg/id3v2/frames/synchronizedlyricsframe.cpp
  mpeg/id3v2/frames/textidentificationframe.cpp
  mpeg/id3v2/frames/uniquefileidentifierframe.cpp
  mpeg/id3v2/frames/unknownframe.cpp
  mpeg/id3v2/frames/unsynchronizedlyricsframe.cpp
  mpeg/id3v2/frames/urllinkframe.cpp
  mpeg/id3v2/frames/chapterframe.cpp
  mpeg/id3v2/frames/tableofcontentsframe.cpp
  mpeg/id3v2/frames/podcastframe.cpp
)

if(WITH_VORBIS)
  set(ogg_SRCS
    ogg/oggfile.cpp
    ogg/oggpage.cpp
    ogg/oggpageheader.cpp
    ogg/xiphcomment.cpp
  )

  set(vorbis_SRCS
    ogg/vorbis/vorbisfile.cpp
    ogg/vorbis/vorbisproperties.cpp
  )

  set(flacs_SRCS
    flac/flacfile.cpp
    flac/flacpicture.cpp
    flac/flacproperties.cpp
    flac/flacmetadatablock.cpp
    flac/flacunknownmetadatablock.cpp
  )

  set(oggflacs_SRCS
    ogg/flac/oggflacfile.cpp
  )

  set(speex_SRCS
    ogg/speex/speexfile.cpp
    ogg/speex/speexproperties.cpp
  )

  set(opus_SRCS
    ogg/opus/opusfile.cpp
    ogg/opus/opusproperties.cpp
  )
endif()

if(WITH_APE)
  set(mpc_SRCS
    mpc/mpcfile.cpp
    mpc/mpcproperties.cpp
  )

  set(ape_SRCS
    ape/apetag.cpp
    ape/apefooter.cpp
    ape/apeitem.cpp
    ape/apefile.cpp
    ape/apeproperties.cpp
  )

  set(wavpack_SRCS
    wavpack/wavpackfile.cpp
    wavpack/wavpackproperties.cpp
  )
endif()

if(WITH_MP4)
  set(mp4_SRCS
    mp4/mp4file.cpp
    mp4/mp4atom.cpp
    mp4/mp4tag.cpp
    mp4/mp4item.cpp
    mp4/mp4properties.cpp
    mp4/mp4coverart.cpp
    mp4/mp4stem.cpp
    mp4/mp4itemfactory.cpp
  )
endif()

if(WITH_TRUEAUDIO)
  set(trueaudio_SRCS
    trueaudio/trueaudiofile.cpp
    trueaudio/trueaudioproperties.cpp
  )
endif()

if(WITH_ASF)
  set(asf_SRCS
    asf/asftag.cpp
    asf/asffile.cpp
    asf/asfproperties.cpp
    asf/asfattribute.cpp
    asf/asfpicture.cpp
  )
endif()

if(WITH_RIFF)
  set(riff_SRCS
    riff/rifffile.cpp
  )

  set(aiff_SRCS
    riff/aiff/aifffile.cpp
    riff/aiff/aiffproperties.cpp
  )

  set(wav_SRCS
    riff/wav/wavfile.cpp
    riff/wav/wavproperties.cpp
    riff/wav/infotag.cpp
  )
endif()

if(WITH_MOD)
  set(mod_SRCS
    mod/modfilebase.cpp
    mod/modfile.cpp
    mod/modtag.cpp
    mod/modproperties.cpp
  )

  set(s3m_SRCS
    s3m/s3mfile.cpp
    s3m/s3mproperties.cpp
  )

  set(it_SRCS
    it/itfile.cpp
    it/itproperties.cpp
  )

  set(xm_SRCS
    xm/xmfile.cpp
    xm/xmproperties.cpp
  )
endif()

if(WITH_DSF)
  set(dsf_SRCS
    dsf/dsffile.cpp
    dsf/dsfproperties.cpp
  )

  set(dsdiff_SRCS
    dsdiff/dsdifffile.cpp
    dsdiff/dsdiffproperties.cpp
    dsdiff/dsdiffdiintag.cpp
  )
endif()

if(WITH_SHORTEN)
  set(shorten_SRCS
    shorten/shortenfile.cpp
    shorten/shortenproperties.cpp
    shorten/shortentag.cpp
  )
endif()

if(WITH_MATROSKA)
  set(matroska_SRCS
    matroska/matroskaattachedfile.cpp
    matroska/matroskaattachments.cpp
    matroska/matroskachapter.cpp
    matroska/matroskachapteredition.cpp
    matroska/matroskachapters.cpp
    matroska/matroskacues.cpp
    matroska/matroskaelement.cpp
    matroska/matroskafile.cpp
    matroska/matroskaproperties.cpp
    matroska/matroskaseekhead.cpp
    matroska/matroskasegment.cpp
    matroska/matroskasimpletag.cpp
    matroska/matroskatag.cpp
  )

  set(ebml_SRCS
    matroska/ebml/ebmlbinaryelement.cpp
    matroska/ebml/ebmlelement.cpp
    matroska/ebml/ebmlmasterelement.cpp
    matroska/ebml/ebmlmkattachments.cpp
    matroska/ebml/ebmlmkchapters.cpp
    matroska/ebml/ebmlmkcues.cpp
    matroska/ebml/ebmlmkseekhead.cpp
    matroska/ebml/ebmlmksegment.cpp
    matroska/ebml/ebmlmkinfo.cpp
    matroska/ebml/ebmlmktracks.cpp
    matroska/ebml/ebmlmktags.cpp
    matroska/ebml/ebmlstringelement.cpp
    matroska/ebml/ebmluintelement.cpp
    matroska/ebml/ebmlfloatelement.cpp
    matroska/ebml/ebmlutils.cpp
    matroska/ebml/ebmlvoidelement.cpp
  )
endif()

set(toolkit_SRCS
  toolkit/tstring.cpp
  toolkit/tstringlist.cpp
  toolkit/tbytevector.cpp
  toolkit/tbytevectorlist.cpp
  toolkit/tvariant.cpp
  toolkit/tbytevectorstream.cpp
  toolkit/tiostream.cpp
  toolkit/tfile.cpp
  toolkit/tfilestream.cpp
  toolkit/tdebug.cpp
  toolkit/tpicturetype.cpp
  toolkit/tpropertymap.cpp
  toolkit/tdebuglistener.cpp
  toolkit/tzlib.cpp
  toolkit/tversionnumber.cpp
)

set(tag_LIB_SRCS
  ${mpeg_SRCS} ${id3v1_SRCS} ${id3v2_SRCS} ${frames_SRCS} ${ogg_SRCS}
  ${vorbis_SRCS} ${oggflacs_SRCS} ${mpc_SRCS} ${ape_SRCS} ${toolkit_SRCS} ${flacs_SRCS}
  ${wavpack_SRCS} ${speex_SRCS} ${trueaudio_SRCS} ${riff_SRCS} ${aiff_SRCS} ${wav_SRCS}
  ${asf_SRCS} ${mp4_SRCS} ${mod_SRCS} ${s3m_SRCS} ${it_SRCS} ${xm_SRCS} ${opus_SRCS}
  ${dsf_SRCS} ${dsdiff_SRCS} ${shorten_SRCS} ${matroska_SRCS} ${ebml_SRCS}
  tag.cpp
  tagunion.cpp
  fileref.cpp
  audioproperties.cpp
  tagutils.cpp
)

=== tests/CMakeLists.txt ===
SET(test_HDR_DIRS
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/toolkit
  ${CMAKE_CURRENT_SOURCE_DIR}/../bindings/c
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mpeg/id3v1
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mpeg/id3v2
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mpeg/id3v2/frames
  ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mpeg
)
IF(WITH_APE)
  SET(test_HDR_DIRS ${test_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/ape
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mpc
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/wavpack
  )
ENDIF()
IF(WITH_ASF)
  SET(test_HDR_DIRS ${test_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/asf
  )
ENDIF()
IF(WITH_MP4)
  SET(test_HDR_DIRS ${test_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mp4
  )
ENDIF()
IF(WITH_RIFF)
  SET(test_HDR_DIRS ${test_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/riff
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/riff/aiff
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/riff/wav
  )
ENDIF()
IF(WITH_TRUEAUDIO)
  SET(test_HDR_DIRS ${test_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/trueaudio
  )
ENDIF()
IF(WITH_VORBIS)
  SET(test_HDR_DIRS ${test_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/ogg
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/ogg/vorbis
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/ogg/flac
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/ogg/speex
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/ogg/opus
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/flac
  )
ENDIF()
IF(WITH_MOD)
  SET(test_HDR_DIRS ${test_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/mod
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/s3m
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/it
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/xm
  )
ENDIF()
IF(WITH_DSF)
  SET(test_HDR_DIRS ${test_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/dsf
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/dsdiff
  )
ENDIF()
IF(WITH_SHORTEN)
  SET(test_HDR_DIRS ${test_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/shorten
  )
ENDIF()
IF(WITH_MATROSKA)
  SET(test_HDR_DIRS ${test_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../taglib/matroska
  )
ENDIF()
INCLUDE_DIRECTORIES(${test_HDR_DIRS})

SET(test_runner_SRCS
  main.cpp
  test_list.cpp
  test_map.cpp
  test_mpeg.cpp
  test_synchdata.cpp
  test_bytevector.cpp
  test_bytevectorlist.cpp
  test_bytevectorstream.cpp
  test_string.cpp
  test_propertymap.cpp
  test_variant.cpp
  test_complexproperties.cpp
  test_file.cpp
  test_fileref.cpp
  test_id3v1.cpp
  test_id3v2.cpp
  test_id3v2framefactory.cpp
  test_sizes.cpp
  test_versionnumber.cpp
)
IF(WITH_TRUEAUDIO)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_trueaudio.cpp
  )
ENDIF()
IF(WITH_VORBIS)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_xiphcomment.cpp
    test_ogg.cpp
    test_oggflac.cpp
    test_flac.cpp
    test_flacpicture.cpp
    test_flacunknownmetadatablock.cpp
    test_opus.cpp
    test_speex.cpp
  )
ENDIF()
IF(WITH_RIFF)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_aiff.cpp
    test_riff.cpp
    test_wav.cpp
    test_info.cpp
  )
ENDIF()
if(WITH_APE)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_ape.cpp
    test_apetag.cpp
    test_wavpack.cpp
    test_mpc.cpp
  )
ENDIF()
IF(WITH_MP4)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_mp4.cpp
    test_mp4item.cpp
    test_mp4coverart.cpp
    test_mp4stem.cpp
  )
ENDIF()
IF(WITH_ASF)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_asf.cpp
  )
ENDIF()
IF(WITH_MOD)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_mod.cpp
    test_s3m.cpp
    test_it.cpp
    test_xm.cpp
  )
ENDIF()
IF(WITH_DSF)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_dsf.cpp
    test_dsdiff.cpp
  )
ENDIF()
IF(WITH_SHORTEN)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_shorten.cpp
  )
ENDIF()
IF(WITH_MATROSKA)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_matroska.cpp
  )
ENDIF()
IF(BUILD_BINDINGS)
  SET(test_runner_SRCS ${test_runner_SRCS}
    test_tag_c.cpp
  )
ENDIF()

INCLUDE_DIRECTORIES(${CPPUNIT_INCLUDE_DIR})

ADD_EXECUTABLE(test_runner ${test_runner_SRCS})
TARGET_LINK_LIBRARIES(test_runner tag ${CPPUNIT_LIBRARIES})
IF(BUILD_BINDINGS)
  TARGET_LINK_LIBRARIES(test_runner tag_c)
ENDIF()

ADD_TEST(test_runner test_runner)
ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND} -V
                  DEPENDS test_runner)

=== bindings/c/CMakeLists.txt ===
set(tag_c_HDR_DIRS
  ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib
  ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/toolkit
  ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/mpeg
  ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/mpeg/id3v2
  ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/mpeg/id3v2/frames
)
if(WITH_ASF)
  set(tag_c_HDR_DIRS ${tag_c_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/asf
  )
endif()
if(WITH_VORBIS)
  set(tag_c_HDR_DIRS ${tag_c_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/ogg
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/ogg/vorbis
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/ogg/flac
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/flac
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/ogg/speex
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/ogg/opus
  )
endif()
if(WITH_APE)
  set(tag_c_HDR_DIRS ${tag_c_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/mpc
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/wavpack
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/ape
  )
endif()
if(WITH_MP4)
  set(tag_c_HDR_DIRS ${tag_c_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/mp4
  )
endif()
if(WITH_TRUEAUDIO)
  set(tag_c_HDR_DIRS ${tag_c_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/trueaudio
  )
endif()
if(WITH_RIFF)
  set(tag_c_HDR_DIRS ${tag_c_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/riff
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/riff/aiff
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/riff/wav
  )
endif()
if(WITH_MOD)
  set(tag_c_HDR_DIRS ${tag_c_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/it
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/mod
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/s3m
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/xm
  )
endif()
if(WITH_DSF)
  set(tag_c_HDR_DIRS ${tag_c_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/dsf
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/dsdiff
  )
endif()
if(WITH_SHORTEN)
  set(tag_c_HDR_DIRS ${tag_c_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/shorten
  )
endif()
if(WITH_MATROSKA)
  set(tag_c_HDR_DIRS ${tag_c_HDR_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/matroska
    ${CMAKE_CURRENT_SOURCE_DIR}/../../taglib/matroska/ebml
  )
endif()
include_directories(${tag_c_HDR_DIRS})

set(tag_c_HDRS tag_c.h)

add_library(tag_c tag_c.cpp ${tag_c_HDRS})

target_include_directories(tag_c INTERFACE
  $<INSTALL_INTERFACE:include/taglib${TAGLIB_INSTALL_SUFFIX}>
)

target_link_libraries(tag_c PRIVATE tag)
set_target_properties(tag_c PROPERTIES
  PUBLIC_HEADER "${tag_c_HDRS}"
  DEFINE_SYMBOL MAKE_TAGLIB_LIB
)
if(VISIBILITY_HIDDEN)
  set_target_properties(tag_c PROPERTIES C_VISIBILITY_PRESET hidden)
endif()
if(BUILD_FRAMEWORK)
  set_target_properties(tag_c PROPERTIES FRAMEWORK TRUE)
endif()

# On Solaris we need to explicitly add the C++ standard and runtime
# libraries to the libs used by the C bindings, because those C bindings
# themselves won't pull in the C++ libs -- and if a C application is
# using the C bindings then we get link errors.
check_library_exists(Crun __RTTI___ "" HAVE_CRUN_LIB)
if(HAVE_CRUN_LIB)
  # Which libraries to link depends critically on which
  # STL version is going to be used by your application
  # and which runtime is in use. While Crun is pretty much
  # the only game in town, the three available STLs -- Cstd,
  # stlport4 and stdcxx -- make this a mess. The KDE-Solaris
  # team supports stdcxx (Apache RogueWave stdcxx 4.1.3).

  # According to http://bugs.kde.org/show_bug.cgi?id=215225 the library can have the following two names:
  find_library(ROGUEWAVE_STDCXX_LIBRARY NAMES stdcxx4 stdcxx)
  if(NOT ROGUEWAVE_STDCXX_LIBRARY)
    message(FATAL_ERROR "Did not find supported STL library (tried stdcxx4 and stdcxx)")
  endif()
  target_link_libraries(tag_c ${ROGUEWAVE_STDCXX_LIBRARY} Crun)
endif()

set_target_properties(tag_c PROPERTIES
  VERSION ${TAGLIB_SOVERSION_MAJOR}.${TAGLIB_SOVERSION_MINOR}.${TAGLIB_SOVERSION_PATCH}
  SOVERSION ${TAGLIB_SOVERSION_MAJOR}
  DEFINE_SYMBOL MAKE_TAGLIB_C_LIB
  INSTALL_NAME_DIR ${CMAKE_INSTALL_FULL_LIBDIR}
)
if(NOT BUILD_SHARED_LIBS)
  target_compile_definitions(tag_c PUBLIC TAGLIB_STATIC)
endif()

if(TAGLIB_INSTALL_SUFFIX)
  if(BUILD_SHARED_LIBS)
    set(TAGLIB_LIBRARY_SUFFIX "${TAGLIB_INSTALL_SUFFIX}${CMAKE_SHARED_LIBRARY_SUFFIX}")
  else()
    set(TAGLIB_LIBRARY_SUFFIX "${TAGLIB_INSTALL_SUFFIX}${CMAKE_STATIC_LIBRARY_SUFFIX}")
  endif()
  set_target_properties(tag_c PROPERTIES SUFFIX ${TAGLIB_LIBRARY_SUFFIX})
endif()

install(TARGETS tag_c
  EXPORT taglibTargets
  FRAMEWORK DESTINATION ${FRAMEWORK_INSTALL_DIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/taglib${TAGLIB_INSTALL_SUFFIX}
)

if(NOT BUILD_FRAMEWORK)
  if(IS_ABSOLUTE ${CMAKE_INSTALL_INCLUDEDIR})
    set(CMAKE_PC_INCLUDEDIR ${CMAKE_INSTALL_INCLUDEDIR})
  else()
    set(CMAKE_PC_INCLUDEDIR "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
  endif()
  if(IS_ABSOLUTE ${CMAKE_INSTALL_LIBDIR})
    set(CMAKE_PC_LIBDIR ${CMAKE_INSTALL_LIBDIR})
  else()
    set(CMAKE_PC_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
  endif()
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/taglib_c.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/taglib_c.pc @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/taglib_c.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
          RENAME taglib${TAGLIB_INSTALL_SUFFIX}_c.pc)
endif()

=== debian/changelog ===
taglib (2.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Bump Standards-Version to 4.7.3.
  * debian/copyright: Update information.
  * debian/libtag2.symbols: Add new symbols.

 -- Boyuan Yang <byang@debian.org>  Thu, 19 Feb 2026 11:59:25 -0500

=== debian/control ===
Source: taglib
Section: libs
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-pkgkde-symbolshelper,
 cmake,
 libcppunit-dev <!nocheck>,
 libutfcpp-dev,
 pkgconf,
 zlib1g-dev,
Build-Depends-Indep:
 doxygen <!nodoc>,
 graphviz <!nodoc>,
Standards-Version: 4.7.3
Homepage: https://taglib.org/
Vcs-Git: https://salsa.debian.org/multimedia-team/taglib.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/taglib
Description: audio meta-data library
 TagLib is a library for reading and editing audio meta data, commonly know as
 tags.
 .
  - A clean, high level, C++ API to handling audio meta data.
  - Format specific APIs for advanced API users.
  - ID3v1, ID3v2, APE, FLAC, Xiph, iTunes-style MP4 and WMA tag formats.
  - MP3, MPC, FLAC, MP4, ASF, AIFF, WAV, TrueAudio, WavPack, Ogg FLAC, Ogg
    Vorbis, Speex and Opus file formats.
  - Basic audio file properties such as length, sample rate, etc.
  - Long term binary and source compatibility.
  - Extensible design, notably the ability to add other formats or extend
  - current formats as a library user.
  - Full support for unicode and internationalized tags.
  - Dual MPL and LGPL licenses.
  - No external toolkit dependencies.

Package: libtag-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libtag-c-dev (= ${binary:Version}),
 libtag2 (= ${binary:Version}),
 zlib1g-dev,
 ${misc:Depends},
Breaks:
 libtag1-dev (<< 2),
Replaces:
 libtag1-dev (<< 2),
Provides:
 libtag1-dev,
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 This is the development package which contains headers for the TagLib Audio
 Meta-Data Library.

Package: libtag-c-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libtag-c2 (= ${binary:Version}),
 libtag-dev (= ${binary:Version}),
 ${misc:Depends},
Breaks:
 libtagc0-dev (<< 2),
Replaces:
 libtagc0-dev (<< 2),
Provides:
 libtagc0-dev,
Description: ${source:Synopsis} - development files for C bindings
 ${source:Extended-Description}
 .
 This is the development package which contains headers for the TagLib Audio
 Meta-Data Library (C bindings).

Package: libtag-c2
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - C bindings
 ${source:Extended-Description}
 .
 This is the runtime package for programs that use the TagLib Audio Meta-Data
 Library (C bindings).

Package: libtag-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 libjs-jquery,
 ${misc:Depends},
Suggests:
 libtag-dev,
Description: ${source:Synopsis} - API documentation
 ${source:Extended-Description}
 .
 This is the documentation package which contains API documentation for the
 TagLib Audio Meta-Data Library.

Package: libtag1-dev
Section: oldlibs
Architecture: any
Depends:
 libtag-dev (= ${binary:Version}),
 ${misc:Depends},
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: libtag2
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This is the runtime package for programs that use the TagLib Audio Meta-Data
 Library.
